"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var GenericSeed_1;
Object.defineProperty(exports, "__esModule", { value: true });
exports.GenericVisitor = exports.GenericSeed = void 0;
const utils_1 = require("../utils");
let GenericSeed = GenericSeed_1 = class GenericSeed {
    static deserialize(deserializer) {
        return deserializer.deserializeAny(new GenericVisitor());
    }
    deserialize(deserializer) {
        return GenericSeed_1.deserialize(deserializer);
    }
};
exports.GenericSeed = GenericSeed;
exports.GenericSeed = GenericSeed = GenericSeed_1 = __decorate([
    (0, utils_1.staticImplements)()
], GenericSeed);
class GenericVisitor {
    visitString(value) {
        return value;
    }
    visitNumber(value) {
        return value;
    }
    visitBigInt(value) {
        return value;
    }
    visitBoolean(value) {
        return value;
    }
    visitSymbol(value) {
        return value;
    }
    visitNull() {
        return null;
    }
    visitObject(access) {
        const result = {};
        let entry;
        while ((entry = access.nextEntry())) {
            result[entry[0]] = entry[1];
        }
        return result;
    }
    visitIterable(access) {
        const result = new Array(access.sizeHint());
        let element;
        while ((element = access.nextElement())) {
            result.push(element);
        }
        return result;
    }
}
exports.GenericVisitor = GenericVisitor;
